/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 22, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.coreservices.cfnetwork.CFFTPStream;

//import dstep.Availability;
import dstep.corefoundation.CFBase;
import dstep.corefoundation.CFDictionary;
import dstep.corefoundation.CFStream;
import dstep.corefoundation.CFURL;
import dstep.coreservices.cfnetwork.CFNetworkDefs;

extern (C)
{
	extern
	{
		const int kCFStreamErrorDomainFTP;
		const CFStringRef kCFStreamPropertyFTPUserName;
		const CFStringRef kCFStreamPropertyFTPPassword;
		const CFStringRef kCFStreamPropertyFTPUsePassiveMode;
		const CFStringRef kCFStreamPropertyFTPResourceSize;
		const CFStringRef kCFStreamPropertyFTPFetchResourceInfo;
		const CFStringRef kCFStreamPropertyFTPFileTransferOffset;
		const CFStringRef kCFStreamPropertyFTPAttemptPersistentConnection;
		const CFStringRef kCFStreamPropertyFTPProxy;
		const CFStringRef kCFStreamPropertyFTPProxyHost;
		const CFStringRef kCFStreamPropertyFTPProxyPort;
		const CFStringRef kCFStreamPropertyFTPProxyUser;
		const CFStringRef kCFStreamPropertyFTPProxyPassword;
		const CFStringRef kCFFTPResourceMode;
		const CFStringRef kCFFTPResourceName;
		const CFStringRef kCFFTPResourceOwner;
		const CFStringRef kCFFTPResourceGroup;
		const CFStringRef kCFFTPResourceLink;
		const CFStringRef kCFFTPResourceSize;
		const CFStringRef kCFFTPResourceType;
		const CFStringRef kCFFTPResourceModDate;
	}
}

extern (C)
{
	CFReadStreamRef CFReadStreamCreateWithFTPURL (CFAllocatorRef alloc, CFURLRef ftpURL);
	int CFFTPCreateParsedResourceListing (CFAllocatorRef alloc, char* buffer, int bufferLength, CFDictionaryRef* parsed);
	CFWriteStreamRef CFWriteStreamCreateWithFTPURL (CFAllocatorRef alloc, CFURLRef ftpURL);
}